module Pageflow
  # Add a +perma_id+ attribute of type integer.
  # The perma_id is automatically generated on create
  # and remains unchanged throughout the models lifecycle.
  module AutoGeneratedPermaId
    extend ActiveSupport::Concern

    included do
      before_save :ensure_perma_id
    end

    def ensure_perma_id
      self.perma_id ||= (self.class.maximum(:perma_id) || 0) + 1
    end
  end
end
