module Pageflow
  class Page < ApplicationRecord
    include SerializedConfiguration
    include NestedRevisionComponent
    include AutoGeneratedPermaId

    belongs_to :chapter, touch: true

    attr_accessor :is_first

    validates_inclusion_of :template, :in => ->(_) { Pageflow.config.page_types.names }

    scope :displayed_in_navigation, -> { where(:display_in_navigation => true) }

    def title
      configuration['title'].presence || configuration['additional_title']
    end

    def page_type
      Pageflow.config.page_types.find_by_name!(template)
    end

    def configuration=(value)
      self.display_in_navigation = value['display_in_navigation']
      super
    end
  end
end
