import 'pageflow/frontend';
import React, { useMemo, useEffect, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { b as _objectWithoutProperties, u as useI18n, _ as _slicedToArray, a as _defineProperty } from './i18n-4dc6c377.js';
import classNames from 'classnames';
import 'use-context-selector';
import 'reselect';
import 'i18n-js';
import 'slugify';
import { u as useBrowserFeature } from './useBrowserFeature-91a4c29d.js';
import { PanoViewer } from '@egjs/view360';
import screenfull from 'screenfull';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}
var EnterFullscreenIcon = (function (_ref) {
  var _ref$styles = _ref.styles,
      styles = _ref$styles === void 0 ? {} : _ref$styles,
      props = _objectWithoutProperties(_ref, ["styles"]);

  return React.createElement("svg", _extends({
    "aria-hidden": "true",
    "data-prefix": "fas",
    "data-icon": "expand",
    className: (styles["svg-inline--fa"] || "svg-inline--fa") + " " + (styles["fa-expand"] || "fa-expand") + " " + (styles["fa-w-14"] || "fa-w-14"),
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 448 512"
  }, props), React.createElement("path", {
    fill: "currentColor",
    d: "M0 180V56c0-13.3 10.7-24 24-24h124c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12H64v84c0 6.6-5.4 12-12 12H12c-6.6 0-12-5.4-12-12zM288 44v40c0 6.6 5.4 12 12 12h84v84c0 6.6 5.4 12 12 12h40c6.6 0 12-5.4 12-12V56c0-13.3-10.7-24-24-24H300c-6.6 0-12 5.4-12 12zm148 276h-40c-6.6 0-12 5.4-12 12v84h-84c-6.6 0-12 5.4-12 12v40c0 6.6 5.4 12 12 12h124c13.3 0 24-10.7 24-24V332c0-6.6-5.4-12-12-12zM160 468v-40c0-6.6-5.4-12-12-12H64v-84c0-6.6-5.4-12-12-12H12c-6.6 0-12 5.4-12 12v124c0 13.3 10.7 24 24 24h124c6.6 0 12-5.4 12-12z"
  }));
});

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$1.apply(this, arguments);
}
var ExitFullscreenIcon = (function (_ref) {
  var _ref$styles = _ref.styles,
      styles = _ref$styles === void 0 ? {} : _ref$styles,
      props = _objectWithoutProperties(_ref, ["styles"]);

  return React.createElement("svg", _extends$1({
    "aria-hidden": "true",
    "data-prefix": "fas",
    "data-icon": "compress",
    className: (styles["svg-inline--fa"] || "svg-inline--fa") + " " + (styles["fa-compress"] || "fa-compress") + " " + (styles["fa-w-14"] || "fa-w-14"),
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 448 512"
  }, props), React.createElement("path", {
    fill: "currentColor",
    d: "M436 192H312c-13.3 0-24-10.7-24-24V44c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v84h84c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12zm-276-24V44c0-6.6-5.4-12-12-12h-40c-6.6 0-12 5.4-12 12v84H12c-6.6 0-12 5.4-12 12v40c0 6.6 5.4 12 12 12h124c13.3 0 24-10.7 24-24zm0 300V344c0-13.3-10.7-24-24-24H12c-6.6 0-12 5.4-12 12v40c0 6.6 5.4 12 12 12h84v84c0 6.6 5.4 12 12 12h40c6.6 0 12-5.4 12-12zm192 0v-84h84c6.6 0 12-5.4 12-12v-40c0-6.6-5.4-12-12-12H312c-13.3 0-24 10.7-24 24v124c0 6.6 5.4 12 12 12h40c6.6 0 12-5.4 12-12z"
  }));
});

var styles = {"button":"ToggleFullscreenButton-module_button__3iBr8 utils-module_unstyledButton__3rgne"};

function ToggleFullscreenButton(props) {
  var _useI18n = useI18n(),
      t = _useI18n.t;

  return (
    /*#__PURE__*/
    React.createElement("button", {
      className: styles.button,
      title: t(props.isFullscreen ? 'exit_fullscreen' : 'enter_fullscreen', {
        scope: 'pageflow_scrolled.public'
      }),
      onClick: function onClick() {
        return props.isFullscreen ? props.onExit() : props.onEnter();
      }
    }, icon(props))
  );
}

function icon(props) {
  if (props.isFullscreen) {
    return (
      /*#__PURE__*/
      React.createElement(ExitFullscreenIcon, null)
    );
  } else {
    return (
      /*#__PURE__*/
      React.createElement(EnterFullscreenIcon, null)
    );
  }
}

var styles$1 = {"wrapper":"Fullscreen-module_wrapper__300hJ"};

function Fullscreen(_ref) {
  var isFullscreen = _ref.isFullscreen,
      children = _ref.children;
  var root = useMemo(function () {
    return document.getElementById('fullscreenRoot');
  }, []);
  useEffect(function () {
    if (isFullscreen) {
      document.body.style.overflow = 'hidden';
    } else {
      document.body.style.overflow = 'initial';
    }
  }, [isFullscreen]);

  if (isFullscreen) {
    return ReactDOM.createPortal(
    /*#__PURE__*/
    React.createElement("div", {
      className: styles$1.wrapper
    }, children), root);
  } else {
    return children;
  }
}

var styles$2 = {"full":"Viewer-module_full__1q18y","container":"Viewer-module_container__3eJ34 Viewer-module_full__1q18y","controls":"Viewer-module_controls__3BTof","spinner":"Viewer-module_spinner__2oRve","spin":"Viewer-module_spin__3jBR2","isLoading":"Viewer-module_isLoading__sQuGw"};

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$2.apply(this, arguments);
}
var SpinnerIcon = (function (_ref) {
  var _ref$styles = _ref.styles,
      props = _objectWithoutProperties(_ref, ["styles"]);

  return React.createElement("svg", _extends$2({
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24"
  }, props), React.createElement("circle", {
    cx: "12",
    cy: "12",
    r: "10",
    stroke: "currentColor",
    strokeWidth: "4",
    opacity: ".23"
  }), React.createElement("path", {
    fill: "currentColor",
    d: "M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z",
    opacity: ".75"
  }));
});

function Viewer(_ref) {
  var imageFile = _ref.imageFile,
      viewerRef = _ref.viewerRef,
      initialYaw = _ref.initialYaw,
      initialPitch = _ref.initialPitch;
  var elRef = useRef();
  var initialYawRef = useRef(initialYaw);
  var initialPitchRef = useRef(initialPitch);
  var touchSupport = useBrowserFeature('touch support');

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      isLoading = _useState2[0],
      setIsLoading = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isFullscreen = _useState4[0],
      setIsFullscreen = _useState4[1]; // When toggling to fullscreen mode, this component renders to a
  // portal div in the body of the document. We do not want to recreate
  // the PanoViewer instead to keep its current state (pitch, yaw etc.).
  // We therefore initialize the PanoViewer on a detached DOM element
  // and render a component called DOMNodeContainer which appends the
  // element on each render. React.memo causes the DOMNodeContainer to
  // render only when either
  // - the parent Viewer component is mounted
  // - Fullscreen component switches between using the portal or not


  function appendViewerTo(parentNode) {
    if (!elRef.current) {
      elRef.current = document.createElement('div');
      elRef.current.className = styles$2.full;
      viewerRef.current = new PanoViewer(elRef.current, {
        image: imageFile.urls.ultra,
        projectionType: imageFile.configuration.projection === 'equirectangular_stereo' ? PanoViewer.PROJECTION_TYPE.STEREOSCOPIC_EQUI : PanoViewer.PROJECTION_TYPE.EQUIRECTANGULAR,
        touchDirection: touchSupport ? PanoViewer.TOUCH_DIRECTION.YAW : PanoViewer.TOUCH_DIRECTION.ALL,
        useZoom: false,
        yaw: initialYawRef.current,
        pitch: initialPitchRef.current
      });
      viewerRef.current.on(PanoViewer.EVENTS.READY, function () {
        viewerRef.current.updateViewportDimensions();
        setIsLoading(false);
      });
    }

    parentNode.appendChild(elRef.current);
    viewerRef.current.updateViewportDimensions();
  }

  useEffect(function () {
    return function () {
      if (elRef.current) {
        viewerRef.current.destroy();
        viewerRef.current = null;
        elRef.current = null;
      }
    };
  }, [viewerRef]);
  useEffect(function () {
    if (initialYawRef.current !== initialYaw) {
      initialYawRef.current = initialYaw;
      viewerRef.current.lookAt({
        yaw: initialYaw
      }, 200);
    }
  }, [initialYaw, viewerRef]);
  useEffect(function () {
    if (initialPitchRef.current !== initialPitch) {
      initialPitchRef.current = initialPitch;
      viewerRef.current.lookAt({
        pitch: initialPitch
      }, 200);
    }
  }, [initialPitch, viewerRef]);
  useEffect(function () {
    function onChange() {
      if (!screenfull.isFullscreen) {
        setIsFullscreen(false);
      }
    }

    if (screenfull.isEnabled) {
      screenfull.on('change', onChange);
      return function () {
        return screenfull.off('change', onChange);
      };
    }
  }, []);
  useEffect(function () {
    function onChange() {
      viewerRef.current.updateViewportDimensions();
    }

    window.addEventListener('resize', onChange);
    return function () {
      return window.removeEventListener('resize', onChange);
    };
  }, [viewerRef]);
  useEffect(function () {
    if (isFullscreen) {
      viewerRef.current.setTouchDirection(PanoViewer.TOUCH_DIRECTION.ALL);
      viewerRef.current.setGyroMode(PanoViewer.GYRO_MODE.YAWPITCH);
      viewerRef.current.setUseZoom(true);
    } else {
      if (touchSupport) {
        viewerRef.current.setTouchDirection(PanoViewer.TOUCH_DIRECTION.YAW);
        viewerRef.current.lookAt({
          pitch: 0,
          fov: 65
        });
      } else {
        viewerRef.current.lookAt({
          fov: 65
        });
      }

      viewerRef.current.setGyroMode(PanoViewer.GYRO_MODE.NONE);
      viewerRef.current.setUseZoom(false);
    }
  }, [isFullscreen, viewerRef, touchSupport]);

  function preventDefaultForArrowUpDown(event) {
    if (event.key === 'ArrowUp' || event.key === 'ArrowDown') {
      event.preventDefault();
    }
  }

  function enterFullscreen() {
    if (screenfull.isEnabled) {
      screenfull.request();
    }

    setIsFullscreen(true);
    viewerRef.current.enableSensor();
  }

  function exitFullscreen() {
    if (screenfull.isEnabled) {
      screenfull.exit();
    }

    setIsFullscreen(false);
  }

  return (
    /*#__PURE__*/
    React.createElement(Fullscreen, {
      isFullscreen: isFullscreen
    },
    /*#__PURE__*/
    React.createElement("div", {
      className: styles$2.container,
      onKeyDown: preventDefaultForArrowUpDown
    },
    /*#__PURE__*/
    React.createElement(DOMNodeContainer, {
      className: styles$2.full,
      onUpdate: function onUpdate(el) {
        return appendViewerTo(el);
      }
    })),
    /*#__PURE__*/
    React.createElement(SpinnerIcon, {
      className: classNames(styles$2.spinner, _defineProperty({}, styles$2.isLoading, isLoading))
    }),
    /*#__PURE__*/
    React.createElement("div", {
      className: styles$2.controls
    },
    /*#__PURE__*/
    React.createElement(ToggleFullscreenButton, {
      isFullscreen: isFullscreen,
      onEnter: enterFullscreen,
      onExit: exitFullscreen
    })))
  );
}
var DOMNodeContainer = React.memo(function (_ref2) {
  var className = _ref2.className,
      onUpdate = _ref2.onUpdate;
  var ref = useRef();
  useEffect(function () {
    var current = ref.current;
    onUpdate(current);
    return function () {
      current.removeChild(current.firstChild);
    };
  });
  return (
    /*#__PURE__*/
    React.createElement("div", {
      ref: ref,
      className: className
    })
  );
}, function () {
  return true;
});

export default Viewer;
